/*****************************************************************************/
/*
                                   Net.h
*/
/*****************************************************************************/

#ifndef NET_H_LOADED
#define NET_H_LOADED 1

#include "wasd.h"

/* output character encoding */
#define NET_WRITE_BUFFERED_NONE     0
#define NET_WRITE_BUFFERED_HTMLESC  1
#define NET_WRITE_BUFFERED_URLENC   2

/**************/
/* structures */
/**************/

/***********************/
/* function prototypes */
/***********************/

NetAccept (SERVICE_STRUCT*);
NetAcceptAst (SERVICE_STRUCT*);
NetAccessDenied (unsigned short, char*, char*);
NetBreakSocket (REQUEST_STRUCT*);
NetBreakSocketAst (REQUEST_STRUCT*);
NetClientAddressLookup (SERVICE_STRUCT*);
NetCreateService ();
NetWriteDirect (unsigned short, char*, int);
NetDummyRead (unsigned short);
NetDummyReadAst (unsigned short);
char* NetGetBgDevice (unsigned short, char*, int);
NetGetServerHostName ();
NetHostNameLookup (char*, int, char*, char*, char*, char*, int*);
NetParseHostString (char*, char*, int, int*);
unsigned long NetHostNameHash (char*);
unsigned long NetHostPortHash (char*, char*);
NetListen ();
NetResponseHeaderAst (REQUEST_STRUCT*);
NetServerShutdown (unsigned short);
char* NetServiceNextHostPort (unsigned long*);
int NetServiceReportConfig (REQUEST_STRUCT*, struct ConfigStruct*);
int NetServiceReportStats (REQUEST_STRUCT*);
NetServiceZeroAccounting ();
NetTcpIpAgentInfo ();
NetTooBusy (unsigned short, char*, char*);
boolean NetServiceConfigured (char*);
NetSetService ();
NetCloseSocket (REQUEST_STRUCT*);
int NetRead (REQUEST_STRUCT*, REQUEST_AST, char*, int);
int NetReadRaw (REQUEST_STRUCT*, REQUEST_AST, char*, int);
NetReadRawAst (REQUEST_STRUCT*);
boolean NetVirtualService (REQUEST_STRUCT*);
boolean NetThisVirtualService (char*, char*);

int NetWrite (REQUEST_STRUCT*, REQUEST_AST, char*, int);
int NetWriteBuffered (REQUEST_STRUCT*, REQUEST_AST, char*, int);
int NetWriteRaw (REQUEST_STRUCT*, REQUEST_AST, char*, int);
NetWriteRawAst (REQUEST_STRUCT*);

/* vector print to network buffer */
#define NetWriteFaol(rq,fs,vp) WriteFormatted(rq,NULL,0,NULL,fs,vp)
/* for naming consistency */
#define NetWriteFao WriteFaoNet

/* definition to flush the buffer only if there is more than a buffer-full */
#define NetWritePartFlush(rq,ast) NetWriteBuffered(rq,ast,NULL,-1)

/* to flush buffered contents completely */
#define NetWriteFullFlush(rq,ast) NetWriteBuffered(rq,ast,NULL,0)

/* initialize the buffer */
#define NetWriteInit(rq) NetWriteBuffered(rq,NULL,NULL,0)

#endif /* NET_H_LOADED */

/*****************************************************************************/

                                 
